//Grid.cpp
#define   UNICODE
#define   _UNICODE
//#define MYDEBUG
#include  <windows.h>
#include  <commctrl.h>
#include  <objbase.h>
#include  <ocidl.h>
#include  <olectl.h>
#include  <tchar.h>
#include  <cstdio>
#include  "Grid.h"
#include  "WinCode.h"

extern WNDPROC   fnEditWndProc;
extern HINSTANCE g_hModule;
extern long      g_CtrlId;

#if defined MYDEBUG
extern FILE*     fp;
#endif


FHGrid::FHGrid()   //C++ Constructor for class FHGrid
{
 #if defined MYDEBUG
 printf("  Entering FHGrid Constructor!\n");
 #endif
 this->pISink=NULL,  this->hWndCtrl=NULL,  m_lRef=0;
 #if defined MYDEBUG
 printf("    this->m_lRef = %d\n", this->m_lRef);
 #endif
 InterlockedIncrement(&g_lObjs);
 #if defined MYDEBUG
 printf("    g_lObjs       = %d\n", g_lObjs);
 printf("    sizeof(*this) = %d\n",sizeof(*this));
 #endif
 #if defined MYDEBUG
 printf("  Leaving FHGrid Constructor!\n");
 #endif
}


HRESULT STDMETHODCALLTYPE FHGrid::QueryInterface(REFIID riid, void** ppv)
{
 #if defined MYDEBUG
 printf("    Entering FHGrid::QueryInterface()\n");
 printf("      this = %d\n", this);
 #endif
 *ppv=0;
 if(riid==IID_IUnknown)
    *ppv=(IGrid*)this;
 else if(riid==IID_IFHGrid)
    *ppv=(IGrid*)this;
 else if(riid==IID_IConnectionPointContainer)
    *ppv=(IConnectionPointContainer*)this;
 else if(riid==IID_IConnectionPoint)
    *ppv=(IConnectionPoint*)this;
 if(*ppv)
 {
    AddRef();
    #if defined MYDEBUG
    printf("      *ppv = %u\n",*ppv);
    printf("    Leaving FHGrid::QueryInterface()\n");
    #endif
    return S_OK;
 }
 #if defined MYDEBUG
 printf("    Leaving FHGrid::QueryInterface()\n");
 #endif

 return(E_NOINTERFACE);
}


ULONG STDMETHODCALLTYPE FHGrid::AddRef()
{
 #if defined MYDEBUG
 printf("    Entering FHGrid::AddRef()\n");
 printf("      m_lRef = %d\n", m_lRef);
 #endif
 InterlockedIncrement(&m_lRef);
 #if defined MYDEBUG
 printf("      m_lRef = %d\n", m_lRef);
 printf("    Leaving FHGrid::AddRef()\n");
 #endif

 return m_lRef;
}


ULONG STDMETHODCALLTYPE FHGrid::Release()
{
 #if defined MYDEBUG
 printf("    Entering FHGrid::Release()\n");
 printf("      m_lRef = %d\n", m_lRef);
 #endif
 if(InterlockedDecrement(&m_lRef)==0)
 {
    #if defined MYDEBUG
    printf("      m_lRef = %d\n", m_lRef);
    printf("      Will Now Delete this ...\n");
    printf("      this->pISink = %u\n\n",this->pISink);
    printf("      i\t\t&this->pISink[i]\t\tthis->pISink[i]\n");
    printf("      ============================================================\n");
    for(size_t i=0; i<MAX_CONNECTIONS; i++)
        printf("      %u\t\t%u\t\t\t\t%u\n",i,&this->pISink[i],this->pISink[i]);
    printf("    \nLeaving FHGrid::Release()\n");
    #endif
    DestroyWindow(this->hWndCtrl);
    CoTaskMemFree(this->pISink);
    delete this;
    return 0;
 }
 #if defined MYDEBUG
 printf("      m_lRef = %d\n", m_lRef);
 printf("    Leaving FHGrid::Release()\n");
 #endif

 return m_lRef;
}


HRESULT STDMETHODCALLTYPE FHGrid::CreateGrid(HWND hParent, BSTR strSetup, int x, int y, int cx, int cy, int iRows, int iCols, int iRowHt, COLORREF iSelBckClr, COLORREF iSelTxtClr, BSTR strFntNme, int iFntSize, int iFntWt)
{
 GridData* pGridData=NULL;
 DWORD dwStyle;
 HWND hGrid=0;
 GridData gd;

 #ifndef UNICODE
 return E_FAIL;
 #endif
 #if defined MYDEBUG
 printf("Entering FHGrid::CreateGrid()\n");
 _ftprintf(fp,_T("Entering FHGrid::CreateGrid()\n"));
 _ftprintf(fp,_T("  this       = %u\n"),this);
 _ftprintf(fp,_T("  hParent    = %u\n"),hParent);
 _ftprintf(fp,_T("  strSetup   = %s\n"),strSetup);
 _ftprintf(fp,_T("  x          = %d\n"),x);
 _ftprintf(fp,_T("  y          = %d\n"),y);
 _ftprintf(fp,_T("  cx         = %d\n"),cx);
 _ftprintf(fp,_T("  cy         = %d\n"),cy);
 _ftprintf(fp,_T("  iRows      = %d\n"),iRows);
 _ftprintf(fp,_T("  iCols      = %d\n"),iCols);
 _ftprintf(fp,_T("  iRowHt     = %d\n"),iRowHt);
 _ftprintf(fp,_T("  iSelBckClr = %d\n"),iSelBckClr);
 _ftprintf(fp,_T("  iSelTxtClr = %d\n"),iSelTxtClr);
 _ftprintf(fp,_T("  strFntNme  = %s\n"),strFntNme);
 _ftprintf(fp,_T("  iFntSize   = %d\n"),iFntSize);
 _ftprintf(fp,_T("  iFntWt     = %d\n"),iFntWt);
 #endif
 dwStyle                       = WS_CHILD | WS_VISIBLE | WS_HSCROLL | WS_VSCROLL;
 gd.hParent                    = hParent;
 gd.cx                         = cx;
 gd.cy                         = cy;
 gd.iRows                      = iRows;
 gd.iCols                      = iCols;
 gd.iRowHeight                 = iRowHt;
 gd.iFontSize                  = iFntSize;
 gd.iFontWeight                = iFntWt;
 gd.iSelectionBackColor        = iSelBckClr;
 gd.iSelectionTextColor        = iSelTxtClr;
 gd.iCtrlId=g_CtrlId;
 wcscpy(gd.szFontName,strFntNme);
 #if defined MYDEBUG
 _ftprintf(fp,_T("  gd.szFontName       = %s\n\n"),gd.szFontName);
 _ftprintf(fp,_T("  g_CtrlId            = %d\n"),g_CtrlId);
 #endif
 hGrid=CreateWindowEx(WS_EX_OVERLAPPEDWINDOW,L"Grid",strSetup,dwStyle,x,y,cx,cy,hParent,(HMENU)g_CtrlId,g_hModule,&gd);
 if(hGrid==0)
    return E_FAIL;
 g_CtrlId++;
 this->hWndCtrl=hGrid;
 pGridData=(GridData*)GetWindowLongPtr(hGrid,0);
 if(!pGridData)
    return E_FAIL;
 pGridData->pComObj=this;

 if(iSelBckClr==0)
    pGridData->iSelectionBackColor=RGB(0x41,0x69,0xE1);  //  RGB_ROYALBLUE;    // %RGB_ROYALBLUE = 0xE16941
 if(iSelTxtClr==0)
    pGridData->iSelectionTextColor=RGB(0x80,0x00,0x00);  //  RGB_MAROON;       // %RGB_MAROON    = 0x000080
 this->SetCellAttributes(0,0,pGridData->iSelectionBackColor,pGridData->iSelectionTextColor);
 SetFocus(hGrid);

 #if defined MYDEBUG
 _ftprintf(fp,_T("  hGrid                          = %u\n"),hGrid);
 _ftprintf(fp,_T("  pGridData                      = %u\n"),pGridData);
 _ftprintf(fp,_T("  pGridData->pComObj             = %u\n"),pGridData->pComObj);
 _ftprintf(fp,_T("  this->hWndCtrl                 = %u\n"),this->hWndCtrl);
 _ftprintf(fp,_T("  &gd                            = %u\n"),&gd);
 _ftprintf(fp,_T("  pGridData->blnRowSelected      = %d\n"),pGridData->blnRowSelected);
 _ftprintf(fp,_T("  pGridData->iSelectionBackColor = %0x\n"),pGridData->iSelectionBackColor);
 _ftprintf(fp,_T("  pGridData->iSelectionTextColor = %0x\n"),pGridData->iSelectionTextColor);
 _ftprintf(fp,_T("Leaving FHGrid::CreateGrid()\n\n"));
 printf("  Leaving FHGrid::CreateGrid()\n");
 #endif

 return S_OK;
}


HRESULT STDMETHODCALLTYPE FHGrid::SetRowCount(int iRowCount, int blnForce)
{
 GridData* pGridData=NULL;
 int iSize=0,blnFree=0;
 HANDLE hHeap=0;
 SCROLLINFO si;
 int i;

 #ifdef MYDEBUG
 _ftprintf(fp,_T("Entering FHGrid::SetRowCount()\n"));
 _ftprintf(fp,_T("  i         blnFree\n"));
 _ftprintf(fp,_T("  =================\n"));
 #endif
 pGridData=(GridData*)GetWindowLongPtr(this->hWndCtrl,0);
 iSize=pGridData->iRows*pGridData->iCols;
 hHeap=GetProcessHeap();
 for(i=0; i<iSize; i++)
 {
     blnFree=HeapFree(hHeap,0,pGridData->pGridMemory[i]);
     #ifdef MYDEBUG
     _ftprintf(fp,_T("  %d\t%d\n"),i,blnFree);
     #endif
 }
 blnFree=HeapFree(hHeap,0,pGridData->pGridMemory);
 #ifdef MYDEBUG
 _ftprintf(fp,_T("\n  HeapFree(hHeap,0,pGridData->pGridMemory) = %d\n"),blnFree);
 #endif
 blnFree=HeapFree(hHeap,0,pGridData->pTextColor);
 #ifdef MYDEBUG
 _ftprintf(fp,_T("  HeapFree(hHeap,0,pGridData->pTextColor) = %d\n"),blnFree);
 #endif
 blnFree=HeapFree(hHeap,0,pGridData->pBackColor);
 #ifdef MYDEBUG
 _ftprintf(fp,_T("  HeapFree(hHeap,0,pGridData->pBackColor) = %d\n"),blnFree);
 #endif

 //Create A New Memory Block
 if(iRowCount < pGridData->iVisibleRows)
 {
    #ifdef MYDEBUG
    _ftprintf(fp,_T("  Got In Where iRowCount < iVisibleRows"));
    #endif
    iRowCount=pGridData->iVisibleRows+1;
 }
 iSize = iRowCount * pGridData->iCols;
 pGridData->pGridMemory=(TCHAR**)HeapAlloc(hHeap,HEAP_ZERO_MEMORY,iSize*sizeof(void*));
 if(!pGridData->pGridMemory)
    return E_FAIL;
 pGridData->iRows=iRowCount;
 ZeroMemory(&si, sizeof(SCROLLINFO));
 si.cbSize=sizeof(SCROLLINFO);
 si.fMask=SIF_RANGE | SIF_PAGE | SIF_POS;
 si.nMin=1;
 si.nMax=pGridData->iRows;
 si.nPage=pGridData->iVisibleRows;
 si.nPos=1;
 SetScrollInfo(this->hWndCtrl,SB_VERT,&si,TRUE);
 pGridData->pTextColor=(COLORREF*)HeapAlloc(hHeap,HEAP_ZERO_MEMORY,iSize*sizeof(void*));
 #ifdef MYDEBUG
 _ftprintf(fp,_T("  pGridData->pTextColor = %u\n"),pGridData->pTextColor);
 #endif
 if(!pGridData->pTextColor)
    return E_FAIL;
 pGridData->pBackColor=(HBRUSH*)HeapAlloc(hHeap,HEAP_ZERO_MEMORY,iSize*sizeof(void*));
 #ifdef MYDEBUG
 _ftprintf(fp,_T("  pGridData->pBackColor = %u\n"),pGridData->pBackColor);
 #endif
 if(!pGridData->pBackColor)
    return E_FAIL;
 #ifdef MYDEBUG
 _ftprintf(fp,_T("Leaving FHGrid::SetRowCount()\n\n"));
 #endif

 return S_OK;
}


HRESULT STDMETHODCALLTYPE FHGrid::GetRowCount(int* iRowCount)
{
 #ifdef MYDEBUG
 _ftprintf(fp,_T("Entering FHGrid::GetRowCount()\n"));
 #endif
 GridData* pGridData=(GridData*)GetWindowLong(this->hWndCtrl,0);
 if(pGridData)
 {
    *iRowCount=pGridData->iRows;
    #ifdef MYDEBUG
    _ftprintf(fp,_T("  *iRowCount = %d\n"),*iRowCount);
    _ftprintf(fp,_T("Leaving FHGrid::GetRowCount()\n"));
    #endif
    return S_OK;
 }
 #ifdef MYDEBUG
 _ftprintf(fp,_T("  *iRowCount = %d\n"),*iRowCount);
 _ftprintf(fp,_T("Leaving FHGrid::GetRowCount()\n"));
 #endif

 return E_FAIL;
}


HRESULT STDMETHODCALLTYPE FHGrid::SetData(int iRow, int iCol, BSTR strData)
{
 GridData* pGridData=NULL;
 HANDLE hHeap=NULL;
 int iIndex;

 #ifdef MYDEBUG
 printf("Called FHGrid::SetData()\n");
 _ftprintf(fp,_T("Entering FHGrid::SetData()\n"));
 _ftprintf(fp,_T("  this         = %u\n"),this);
 _ftprintf(fp,_T("  iRow         = %d\n"),iRow);
 _ftprintf(fp,_T("  iCol         = %d\n"),iCol);
 _ftprintf(fp,_T("  strData      = %s\n"),strData);
 #endif
 pGridData=(GridData*)GetWindowLongPtr(this->hWndCtrl,0);
 if(pGridData)
 {
    if(iRow && iRow<=pGridData->iRows)
    {
       if(iCol && iCol<=pGridData->iCols)
       {
          iIndex=dwIdx(iRow,iCol);
          hHeap=GetProcessHeap();
          #ifdef MYDEBUG
          _ftprintf(fp,_T("  iIndex       = %d\n"),iIndex);
          _ftprintf(fp,_T("  pGridData->pGridMemory[iIndex] = %u\n"),pGridData->pGridMemory[iIndex]);
          _ftprintf(fp,_T("  pGridData->pGridMemory[iIndex] = %s\n"),pGridData->pGridMemory[iIndex]);
          #endif
          if(pGridData->pGridMemory[iIndex]==NULL)
          {
             #ifdef MYDEBUG
             _ftprintf(fp,_T("  Got In Where Memory Is Null\n"));
             #endif
             pGridData->pGridMemory[iIndex]=(TCHAR*)HeapAlloc(hHeap,HEAP_ZERO_MEMORY,(SysStringLen(strData)*sizeof(TCHAR))+sizeof(TCHAR));
             if(pGridData->pGridMemory[iIndex])
                _tcscpy(pGridData->pGridMemory[iIndex],strData);
             else
                return S_FALSE;
          }
          else
          {
             if(wcscmp(pGridData->pGridMemory[iIndex],strData)==0)  // Both Strings Are The Same, So No Need To Replace.  Therefore, Just Return.
             {
                #ifdef MYDEBUG
                _ftprintf(fp,_T("  Got In Where Parameter Is Same As Memory, So Just Return.\n"));
                #endif
                return S_OK;
             }
             else
             {
                #ifdef MYDEBUG
                _ftprintf(fp,_T("  Got In Where We'll Allocate Memory And Copy Parameter To it.\n"));
                #endif
                HeapFree(hHeap,0,pGridData->pGridMemory[iIndex]);
                pGridData->pGridMemory[iIndex]=(TCHAR*)HeapAlloc(hHeap,HEAP_ZERO_MEMORY,(SysStringLen(strData)*sizeof(TCHAR))+sizeof(TCHAR));
                if(pGridData->pGridMemory[iIndex])
                   _tcscpy(pGridData->pGridMemory[iIndex],strData);
                else
                   return S_FALSE;
             }
          }
       }
       else
          return S_FALSE;
    }
    else
       return S_FALSE;
 }
 else
    return S_FALSE;
 #ifdef MYDEBUG
 _ftprintf(fp,_T("Leaving FHGrid::SetData()\n\n"));
 #endif

 return S_OK;
}


HRESULT STDMETHODCALLTYPE FHGrid::GetData(int iRow, int iCol, BSTR* strData)
{
 #ifdef MYDEBUG
 printf("Called FHGrid::GetData()\n");
 #endif
 GridData* pGridData=(GridData*)GetWindowLongPtr(this->hWndCtrl,0);
 if(pGridData)
 {
    if(iRow<=pGridData->iRows && iRow>0 && iCol<=pGridData->iCols && iCol>0)
    {
       int iIndex=dwIdx(iRow,iCol);
       SysReAllocString(strData,pGridData->pGridMemory[iIndex]);
       return S_OK;
    }
 }

 return E_FAIL;
}


HRESULT STDMETHODCALLTYPE FHGrid::FlushData()
{
 GridData* pGridData=NULL;
 HWND hGrid;

 #ifdef MYDEBUG
 printf("Called FHGrid::FlushData()\n");
 _ftprintf(fp,_T("  Entering FHGrid::FlushData()\n"));
 #endif
 hGrid=this->hWndCtrl;
 pGridData=(GridData*)GetWindowLongPtr(hGrid,0);
 #ifdef MYDEBUG
 _ftprintf(fp,_T("    hGrid     = %u\n"),hGrid);
 _ftprintf(fp,_T("    pGridData = %u\n"),pGridData);
 #endif
 if(pGridData->hCtrlInCell)
 {
    #ifdef MYDEBUG
    _ftprintf(fp,_T("    Got In Where pGridData->hCtrlInCell = TRUE!\n"));
    #endif
    int iLen=GetWindowTextLength(pGridData->hCtrlInCell);
    HANDLE hHeap=GetProcessHeap();
    TCHAR* pZStr=(TCHAR*)HeapAlloc(hHeap,HEAP_ZERO_MEMORY,(iLen+1)*sizeof(TCHAR));
    if(pZStr)
    {
       GetWindowText(pGridData->hCtrlInCell,pZStr,iLen+1);
       BSTR strData=SysAllocString(pZStr);
       this->SetData(pGridData->iEditedRow,pGridData->iEditedCol,strData);
       SetWindowLongPtr(pGridData->hCtrlInCell,GWLP_WNDPROC,(LONG_PTR)fnEditWndProc);
       SetParent(pGridData->hCtrlInCell,hGrid);
       SetWindowPos(pGridData->hCtrlInCell,HWND_BOTTOM,0,0,0,0,SWP_HIDEWINDOW);
       pGridData->hCtrlInCell=0;
       this->Refresh();
    }
    else
    {
       return E_FAIL;
    }
 }
 #ifdef MYDEBUG
 _ftprintf(fp,_T("  Leaving FHGrid::FlushData()\n"));;
 #endif


 return S_OK;
}


HRESULT STDMETHODCALLTYPE FHGrid::Refresh()
{
 int iRows,iCols,iCountCells,iReturn,iIdx;
 GridData* pGridData=NULL;
 TCHAR* pText=NULL;
 SCROLLINFO si;

 #ifdef MYDEBUG
 printf("Called FHGrid::Refresh()\n");
 _ftprintf(fp,_T("Entering FHGrid::Refresh()\n"));
 #endif
 pGridData=(GridData*)GetWindowLongPtr(this->hWndCtrl,0);
 #ifdef MYDEBUG
 _ftprintf(fp,_T("  pGridData    = %u\n"),pGridData);
 #endif
 if(pGridData)
 {
    iRows       = pGridData->iVisibleRows;
    iCols       = pGridData->iCols;
    iCountCells =iRows*iCols;
    si.cbSize   = sizeof(SCROLLINFO);
    si.fMask    = SIF_POS;
    iReturn     = GetScrollInfo(this->hWndCtrl,SB_VERT,&si);
    #ifdef MYDEBUG
    _ftprintf(fp,_T("  iReturn                 = %d\n"),iReturn);
    _ftprintf(fp,_T("  pGridData->iVisibleRows = %d\n"),pGridData->iVisibleRows);
    _ftprintf(fp,_T("  pGridData->iCols        = %d\n"),pGridData->iCols);
    _ftprintf(fp,_T("  iCountCells             = %d\n"),iCountCells);
    _ftprintf(fp,_T("  si.nPos                 = %d\n\n"),si.nPos);
    _ftprintf(fp,_T("  i    pGridData->pCellHandles[i]  pGridData->pGridMemory[i]    pText   pGridData->pBackColor[iIdx]  pGridData->pTextColor[iIdx]\n"));
    _ftprintf(fp,_T("  ==============================================================================================================================\n"));
    #endif
    if(iReturn)
    {
       for(int i=0; i<iCountCells; i++)
       {
           iIdx=iCols*(si.nPos-1)+i;
           SetWindowLongPtr(pGridData->pCellHandles[i],0,(LONG_PTR)pGridData->pGridMemory[iIdx]);
           SetWindowLongPtr(pGridData->pCellHandles[i],2*sizeof(void*),(LONG_PTR)pGridData->pTextColor[iIdx]);
           SetWindowLongPtr(pGridData->pCellHandles[i],3*sizeof(void*),(LONG_PTR)pGridData->pBackColor[iIdx]);
           InvalidateRect(pGridData->pCellHandles[i],NULL, TRUE);
           pText=(TCHAR*)pGridData->pGridMemory[i];
           #ifdef MYDEBUG
           _ftprintf
           (
             fp,
             _T("  %d\t\t%u\t\t\t%u\t\t\t%s\t\t\t0x%x\t\t\t0x%x\n"),
             i,pGridData->pCellHandles[i],pGridData->pGridMemory[i],pText,pGridData->pBackColor[iIdx],pGridData->pTextColor[iIdx]
           );
           #endif
       }
    }
 }
 #ifdef MYDEBUG
 _ftprintf(fp,_T("Leaving FHGrid::Refresh()\n"));
 #endif

 return S_OK;
}


HRESULT STDMETHODCALLTYPE FHGrid::GetVisibleRows(int* iVisibleRows)
{
 GridData* pGridData=(GridData*)GetWindowLongPtr(this->hWndCtrl,0);
 if(pGridData)
 {
    *iVisibleRows=pGridData->iVisibleRows;
    return S_OK;
 }

 return E_FAIL;
}



HRESULT STDMETHODCALLTYPE FHGrid::GethGrid(HWND* hWnd)
{
 GridData* pGridData=(GridData*)GetWindowLongPtr(this->hWndCtrl,0);
 if(pGridData)
 {
    *hWnd=pGridData->hGrid;
    return S_OK;
 }

 return E_FAIL;
}


HRESULT STDMETHODCALLTYPE FHGrid::GethCell(int iRow, int iCol, HWND* hCell)
{
 GridData* pGridData=(GridData*)GetWindowLongPtr(this->hWndCtrl,0);
 if(pGridData)
 {
    if(iRow<=pGridData->iRows && iRow)
    {
       if(iCol<=pGridData->iCols && iCol)
       {
          int iIndex=dwIdx(iRow,iCol);
          *hCell=pGridData->pCellHandles[iIndex];
          return S_OK;
       }
    }
 }

 return E_FAIL;
}


HRESULT STDMETHODCALLTYPE FHGrid::GethComboBox(int iCol, HWND* hCombo)
{
 #ifdef MYDEBUG
 _ftprintf(fp,_T("Entering FHGrid::GethComboBox()\n"));
 #endif
 GridData* pGridData=(GridData*)GetWindowLongPtr(this->hWndCtrl,0);
 if(pGridData->pCellCtrlTypes[iCol-1]==GRID_CELL_CTRL_COMBO)
    *hCombo=(HWND)pGridData->pCtrlHdls[iCol-1];
 else
    return E_FAIL;
 #ifdef MYDEBUG
 _ftprintf(fp,_T("  *hCombo = %u\n"),*hCombo);
 _ftprintf(fp,_T("Leaving FHGrid::GethComboBox()\n\n"));
 #endif

 return S_OK;
}


HRESULT STDMETHODCALLTYPE FHGrid::SetCellAttributes(int iRow, int iCol, COLORREF iBackColor, COLORREF iTextColor)
{
 int iIdx=0,i=0,blnFound=0;
 GridData* pGridData=NULL;

 #if defined MYDEBUG
 printf("Called FHGrid::SetCellAttributes()\n");
 _ftprintf(fp,_T("  Entering FHGrid::SetCellAttributes()\n"));
 _ftprintf(fp,_T("    iRow       = %u\n"),iRow);
 _ftprintf(fp,_T("    iCol       = %u\n"),iCol);
 _ftprintf(fp,_T("    iBackColor = 0x%x\n"),iBackColor);
 _ftprintf(fp,_T("    iTextColor = 0x%x\n"),iTextColor);
 #endif
 pGridData=(GridData*)GetWindowLongPtr(this->hWndCtrl,0);
 if(iRow && iCol)
 {
    #if defined MYDEBUG
    _ftprintf(fp,_T("    Got In Where iRow And iCol Are Both Something!\n"));
    #endif
    iIdx=dwIdx(iRow,iCol);
    pGridData->pTextColor[iIdx] = iTextColor;
    #if defined MYDEBUG
    _ftprintf(fp,_T("    iIdx       = %u\n"),iIdx);
    #endif
 }
 else
 {
    #if defined MYDEBUG
    _ftprintf(fp,_T("    Got In Where Either iRow Or iCol Ain't Shit!\n"));
    #endif
 }
 #if defined MYDEBUG
 _ftprintf(fp,_T("    pGridData->iCols               = %d\n"),pGridData->iCols);
 _ftprintf(fp,_T("    iIdx                           = %u\n"),iIdx);
 _ftprintf(fp,_T("    pGridData->pTextColor          = %d\n"),pGridData->pTextColor);
 _ftprintf(fp,_T("    pGridData->pTextColor[iIdx]    = 0x%x\n"),pGridData->pTextColor[iIdx]);
 _ftprintf(fp,_T("    pGridData->pCellHandles[iIdx]  = %u\n"),pGridData->pCellHandles[iIdx]);
 _ftprintf(fp,_T("    pGridData->pCreatedColors[0]   = %u\n"),pGridData->pCreatedColors[0]);
 _ftprintf(fp,_T("    pGridData->pCreatedBrushes[0]  = %u\n\n"),pGridData->pCreatedBrushes[0]);
 _ftprintf(fp,_T("    i          pGridData->pCreatedColors[i]            iBackColor\n"));
 _ftprintf(fp,_T("    =============================================================\n"));
 #endif
 //pGridMemory                         As Dword Ptr  'Will be storing ZStr Ptrs here.  We need a
 //pTextColor                          As Dword Ptr  'Will be storing RGB values here, i.e., %Red, %Blue, etc
 //pBackColor                          As Dword Ptr  'Will be storing HBRUSHs here.  May be zero for default brush.
 //pCreatedColors                      As Dword Ptr  'Colors so far asked for by user per grid instance, e.g., %Red, %Yellow, %Blue, etc.
 //pCreatedBrushes                     As Dword Ptr  'Will be storing created HBRUSHs here.  Accumulate them. Numbers such as &HA0556789
 for(i=1; i<=pGridData->pCreatedColors[0]; i++)
 {
     #if defined MYDEBUG
     _ftprintf(fp,_T("    %d\t\t0x%x\t\t0x%x\n"),i,pGridData->pCreatedColors[i],iBackColor);
     #endif
     if(pGridData->pCreatedColors[i]==iBackColor)
     {
        blnFound=TRUE;
        break;
     }
 }
 #if defined MYDEBUG
 _ftprintf(fp,_T("    blnFound = %d\n"),blnFound);
 _ftprintf(fp,_T("    i        = %d\n"),i);
 #endif
 if(blnFound)  // Color Was Already Created
 {
    if(iRow && iCol)
    {
       pGridData->pBackColor[iIdx]=pGridData->pCreatedBrushes[i];
    }
    #if defined MYDEBUG
    _ftprintf(fp,_T("\n"));
    _ftprintf(fp,_T("    Got In Where blnFound = %True!\n"));
    _ftprintf(fp,_T("    pGridData->pCreatedBrushes[i] = 0x%x\n"),pGridData->pCreatedBrushes[i]);
    #endif
 }
 else          // Need To Create Brush And Store It
 {
    #if defined MYDEBUG
    _ftprintf(fp,_T("\n"));
    _ftprintf(fp,_T("    Got In Where blnFound = False!\n"));
    _ftprintf(fp,_T("    pGridData->pCreatedBrushes[0] = %d   << Before\n"),pGridData->pCreatedBrushes[0]);
    #endif
    if((int)pGridData->pCreatedBrushes[0]<MAX_COLORS)  // Test to see if pGridData->pCreatedBrushes[0]
    {                                                  // is less than 15, i.e., %MAX_COLORS
        int iCreatedBrushes=(int)pGridData->pCreatedBrushes[0];
        iCreatedBrushes++;
        pGridData->pCreatedBrushes[0]=(HBRUSH)iCreatedBrushes;
        int iCreatedColors=(int)pGridData->pCreatedColors[0];
        iCreatedColors++;
        pGridData->pCreatedColors[0]=(COLORREF)iCreatedColors;
        #if defined MYDEBUG
        _ftprintf(fp,_T("    pGridData->pCreatedColors[0] = %d\n"),pGridData->pCreatedColors[0]);
        _ftprintf(fp,_T("    Will Be Able To Create Another Brush!\n"));
        #endif
     }
     else
     {
        #if defined MYDEBUG
        _ftprintf(fp,_T("    Can't Create Another Brush!\n"));
        _ftprintf(fp,_T("  Leaving IGrid_SetCellAttributes()\n"));
        #endif
        return E_FAIL;                                // We've already created 15 brushes (Or Whatever MAX_COLORS Is).
     }
     #if defined MYDEBUG
     _ftprintf(fp,_T("    pGridData->pCreatedBrushes[0] = %d   << After\n"),pGridData->pCreatedBrushes[0]);
     #endif
     pGridData->pCreatedBrushes[(int)pGridData->pCreatedBrushes[0]] = CreateSolidBrush(iBackColor);
     pGridData->pCreatedColors[pGridData->pCreatedColors[0]]   = iBackColor;
     #if defined MYDEBUG
     _ftprintf(fp,_T("    pGridData->pCreatedBrushes[(int)pGridData->pCreatedBrushes[0]] = 0x%x\n"),pGridData->pCreatedBrushes[(int)pGridData->pCreatedBrushes[0]]);
     #endif
     if(iRow && iCol)
     {
        pGridData->pBackColor[iIdx] = pGridData->pCreatedBrushes[(int)pGridData->pCreatedBrushes[0]];
        #if defined MYDEBUG
        _ftprintf(fp,_T("    Have Just Assigned A Newly Created Brush To pBackColor[] At correct Location\n"));
        _ftprintf(fp,_T("    pGridData->pBackColor[iIdx] = 0x%x\n"),pGridData->pBackColor[iIdx]);
        #endif
     }
 }
 #if defined MYDEBUG
 _ftprintf(fp,_T("  Leaving FHGrid::SetCellAttributes()\n\n"));
 #endif

 return S_OK;
}


HRESULT STDMETHODCALLTYPE FHGrid::DeleteRow(int iRow)
{
 #if defined MYDEBUG
 _ftprintf(fp,_T("Entering FHGrid::DeleteRow()\n"));
 #endif
 GridData* pGridData=(GridData*)GetWindowLongPtr(this->hWndCtrl,0);
 int iSize=(pGridData->iRows-1)*pGridData->iCols-1;
 int iStart=dwIdx(iRow,1);
 int iCols=pGridData->iCols;
 for(int i=iStart; i<=iSize; i++)
 {
     pGridData->pGridMemory[i] = pGridData->pGridMemory[i+iCols];
     pGridData->pTextColor[i]  = pGridData->pTextColor[i+iCols];
     pGridData->pBackColor[i]  = pGridData->pBackColor[i+iCols];
 }
 iStart=dwIdx(pGridData->iRows,1);
 for(int i=iStart; i<iStart+iCols; i++)
 {
     pGridData->pGridMemory[i] = 0;
     pGridData->pTextColor[i]  = 0;
     pGridData->pBackColor[i]  = 0;
 }
 for(int i=1; i<=iCols; i++)
     pGridData->pComObj->SetCellAttributes(iRow,i,pGridData->iSelectionBackColor,pGridData->iSelectionTextColor);
 #if defined MYDEBUG
 _ftprintf(fp,_T("Leaving FHGrid::DeleteRow()\n"));
 #endif

 return S_OK;
}


HRESULT FHGrid::EnumConnectionPoints(IEnumConnectionPoints** ppEnum)
{
 #ifdef MYDEBUG
 printf("Called FHGrid::EnumConnectionPoints()\n");
 #endif
 return E_NOTIMPL;
}


HRESULT FHGrid::FindConnectionPoint(REFIID riid, IConnectionPoint** ppCP)
{
 #ifdef MYDEBUG
 printf("Entering FHGrid::FindConnectionPoint()\n");
 printf("  this  = %u\n",this);
 printf("  *ppCP = %u\n",*ppCP);
 #endif
 HRESULT hr=this->QueryInterface(IID_IConnectionPoint,(void**)ppCP);
 if(SUCCEEDED(hr))
 {
    #ifdef MYDEBUG
    printf("  QueryInterface(IID_IConnectionPoint) Succeeded!\n");
    printf("  *ppCP = %u\n",*ppCP);
    printf("Leaving FHGrid::FindConnectionPoint()\n");
    #endif
    return hr;
 }
 else
 {
    #ifdef MYDEBUG
    printf("  QueryInterface(IID_IConnectionPoint) Failed!\n");
    printf("Leaving FHGrid::FindConnectionPoint()\n");
    #endif
    return E_NOINTERFACE;
 }
}


HRESULT FHGrid::GetConnectionInterface(IID* pIID)
{
 return E_NOTIMPL;
}


HRESULT FHGrid::GetConnectionPointContainer(IConnectionPointContainer** ppCPC)
{
 return E_NOTIMPL;
}


HRESULT FHGrid::Advise(IUnknown* pUnkSink, DWORD* pdwCookie)
{
 int blnFoundOpenSlot=FALSE,i;

 #ifdef MYDEBUG
 printf("  Entering FHGrid::Advise()\n");
 printf("    this     = %u\n",this);
 printf("    pUnkSink = %u\n\n",pUnkSink);
 printf("    i   &this->pISink[i]     this->pISink[i]\n");
 printf("    ===========================================\n");
 #endif
 for(i=0; i<MAX_CONNECTIONS; i++)
 {
     #ifdef MYDEBUG
     printf("    %d\t%u\t\t\t\t%d\n",i,&this->pISink[i],this->pISink[i]);
     #endif
     if(this->pISink[i]==0)
     {
        blnFoundOpenSlot=TRUE;
        break;
     }
 }
 if(blnFoundOpenSlot)
 {
    HRESULT hr=pUnkSink->QueryInterface(IID_IFHGridEvents,(void**)&this->pISink[i]);
    if(SUCCEEDED(hr))
    {
       #ifdef MYDEBUG
       printf("    i               = %d\n",i);
       printf("    pUnkSink->QueryInterface() For Client Sink Succeeded!\n");
       printf("    this->pISink[i] = %u\n",this->pISink[i]);
       printf("  Leaving FHGrid::Advise()\n");
       #endif
       *pdwCookie=(DWORD)i;
       return S_OK;
    }
    else
    {
       #ifdef MYDEBUG
       printf("    pUnkSink->QueryInterface() For Client Sink Failed!\n");
       #endif
    }
 }
 else
 {
    #ifdef MYDEBUG
    printf("    Couldn't Find An Open Slot To Store Connection!\n");
    #endif
 }
 #ifdef MYDEBUG
 printf("  Leaving FHGrid::Advise()\n");
 #endif

 return E_FAIL;
}


HRESULT FHGrid::Unadvise(DWORD dwCookie)
{
 #ifdef MYDEBUG
 printf("Entering FHGrid::Unadvise()\n");
 printf("  dwCookie = %u\n",dwCookie);
 #endif
 IUnknown* pIUnknown=this->pISink[dwCookie];
 pIUnknown->Release();
 this->pISink[dwCookie]=0;
 #ifdef MYDEBUG
 printf("  pIUnknown = %u\n",pIUnknown);
 printf("Leaving FHGrid::Unadvise()\n");
 #endif

 return NOERROR;
}


HRESULT FHGrid::EnumConnections(IEnumConnections** ppEnum)
{
 return E_NOTIMPL;
}


FHGrid::~FHGrid()  //C++ Destructor for class FHGrid
{
 #if defined MYDEBUG
 printf("  Entering FHGrid Destructor!\n");
 printf("    g_lObjs = %d\n", g_lObjs);
 #endif
 InterlockedDecrement(&g_lObjs);
 #if defined MYDEBUG
 printf("    g_lObjs = %d\n", g_lObjs);
 printf("  Leaving FHGrid Destructor!\n");
 #endif
}

// Grid Class Factory
GridClassFactory::GridClassFactory()
{
 #if defined MYDEBUG
 printf("    Entering GridClassFactory Constructor!\n");
 #endif
 m_lRef=0;
 #if defined MYDEBUG
 printf("      this->m_lRef = %d\n", this->m_lRef);
 #endif
 #if defined MYDEBUG
 printf("    Leaving GridClassFactory Constructor!\n");
 #endif
}


GridClassFactory::~GridClassFactory()  //GridClassFactory Destructor
{
 #if defined MYDEBUG
 printf("  Entering GridClassFactory Destructor!\n");
 #endif
 #if defined MYDEBUG
 printf("    this->m_lRef = %d\n", this->m_lRef);
 #endif
 #if defined MYDEBUG
 printf("  Leaving GridClassFactory Destructor!\n");
 #endif
}


HRESULT STDMETHODCALLTYPE GridClassFactory::QueryInterface(REFIID riid, void** ppv)
{
 printf("    Entering GridClassFactory::QueryInterface()\n");
 *ppv=0;
 if(riid==IID_IUnknown || riid==IID_IClassFactory)
    *ppv=this;
 #if defined MYDEBUG
 printf("      *ppv = %u\n", *ppv);
 #endif
 if(*ppv)
 {
    AddRef();
    printf("    Leaving GridClassFactory::QueryInterface()\n");
    return S_OK;
 }

 return E_NOINTERFACE;
}


ULONG STDMETHODCALLTYPE GridClassFactory::AddRef()
{
 #if defined MYDEBUG
 printf("      Entering GridClassFactory::AddRef()!\n");
 printf("        this->m_lRef = %d\n", this->m_lRef);
 #endif
 InterlockedIncrement(&m_lRef);
 #if defined MYDEBUG
 printf("        this->m_lRef = %d\n", this->m_lRef);
 printf("      Leaving GridClassFactory::AddRef()!\n");
 #endif

 return this->m_lRef;
}


ULONG STDMETHODCALLTYPE GridClassFactory::Release()
{
 #if defined MYDEBUG
 printf("  Entering GridClassFactory::Release()!\n");
 printf("    this->m_lRef = %d\n", this->m_lRef);
 #endif
 InterlockedDecrement(&m_lRef);
 if(this->m_lRef==0)
 {
    printf("    this->m_lRef = %d\n", this->m_lRef);
    delete this;
    #if defined MYDEBUG
    printf("    GridClassFactory Has Been Destroyed!\n");
    printf("  Leaving GridClassFactory::Release()!\n");
    #endif
    return 0;
 }
 #if defined MYDEBUG
 printf("    this->m_lRef = %d\n", this->m_lRef);
 printf("  Leaving GridClassFactory::Release()!\n");
 #endif

 return m_lRef;
}


HRESULT STDMETHODCALLTYPE GridClassFactory::CreateInstance(LPUNKNOWN pUnkOuter, REFIID riid, void** ppvObj)
{
 FHGrid* pGrid=NULL;
 HRESULT hr;

 #if defined MYDEBUG
 printf("  Entering GridClassFactory::CreateInstance()\n");
 #endif
 *ppvObj=0;
 pGrid=new FHGrid;
 #if defined MYDEBUG
 printf("    pGrid          = %u\n",pGrid);
 printf("    sizeof(*pGrid) = %d\n",sizeof(*pGrid));
 #endif
 if(pGrid==NULL)
    return E_OUTOFMEMORY;
 hr=pGrid->QueryInterface(riid,ppvObj);
 if(FAILED(hr))
    delete pGrid;
 else
 {
    pGrid->pISink=(IGridEvents**)CoTaskMemAlloc(MAX_CONNECTIONS*sizeof(void*));
    #if defined MYDEBUG
    printf("    pGrid->pISink = %u\n",pGrid->pISink);
    printf("    pGrid->pISink[0] = %u\n",pGrid->pISink[0]);
    printf("    pGrid->pISink[1] = %u\n",pGrid->pISink[1]);
    printf("    pGrid->pISink[2] = %u\n",pGrid->pISink[2]);
    printf("    pGrid->pISink[3] = %u\n",pGrid->pISink[3]);
    #endif
    if(pGrid->pISink==NULL)
       return E_OUTOFMEMORY;
    else
    {
       pGrid->pISink[0]=(IGridEvents*)0;
       pGrid->pISink[1]=(IGridEvents*)NULL;
       pGrid->pISink[2]=(IGridEvents*)NULL;
       pGrid->pISink[3]=(IGridEvents*)NULL;
       #if defined MYDEBUG
       printf("    pGrid->pISink = %u\n",pGrid->pISink);
       printf("    pGrid->pISink[0] = %u\n",pGrid->pISink[0]);
       printf("    pGrid->pISink[1] = %u\n",pGrid->pISink[1]);
       printf("    pGrid->pISink[2] = %u\n",pGrid->pISink[2]);
       printf("    pGrid->pISink[3] = %u\n",pGrid->pISink[3]);
       #endif
    }
 }
 #if defined MYDEBUG
 printf("  Leaving GridClassFactory::CreateInstance()\n");
 #endif

 return hr;
}


HRESULT STDMETHODCALLTYPE GridClassFactory::LockServer(BOOL fLock)
{
 if(fLock)
    InterlockedIncrement(&g_lLocks);
 else
    InterlockedDecrement(&g_lLocks);

 return S_OK;
}


void Initialize()
{
 INITCOMMONCONTROLSEX uCC;
 TCHAR szClassName[16];
 short int iRet=0;
 WNDCLASSEX wc;

 #if defined MYDEBUG
 printf("    Entering Initialize()\n");
 #endif

 uCC.dwSize = sizeof(uCC);             // Initialize Common Controls (need header control).
 uCC.dwICC  = ICC_LISTVIEW_CLASSES;
 InitCommonControlsEx(&uCC);

 _tcscpy(szClassName,_T("Grid"));      // Register Grid Class
 wc.lpszClassName  = szClassName;
 wc.lpfnWndProc    = fnGridProc;
 wc.cbSize         = sizeof(wc);
 wc.style          = 0;
 wc.cbClsExtra     = 0;
 wc.cbWndExtra     = sizeof(void*);
 wc.hInstance      = g_hModule;
 wc.hIcon          = LoadIcon(NULL,IDI_APPLICATION);
 wc.hCursor        = LoadCursor(NULL,IDC_ARROW);
 wc.hbrBackground  = (HBRUSH)GetStockObject(LTGRAY_BRUSH);
 wc.lpszMenuName   = NULL;
 wc.hIconSm        = NULL;
 iRet              = RegisterClassEx(&wc);
 #if defined MYDEBUG
 printf("      RegisterClassEx(Grid) = %d\n",iRet);
 #endif

 _tcscpy(szClassName,_T("Pane"));      // Register Pane Class
 wc.lpszClassName  = szClassName;
 wc.lpfnWndProc    = fnPaneProc;
 wc.cbSize         = sizeof(wc);
 wc.style          = 0;
 wc.cbClsExtra     = 0;
 wc.cbWndExtra     = sizeof(void*);
 wc.hInstance      = g_hModule;
 wc.hIcon          = LoadIcon(NULL,IDI_APPLICATION);
 wc.hCursor        = LoadCursor(NULL,IDC_ARROW);
 wc.hbrBackground  = (HBRUSH)GetStockObject(WHITE_BRUSH);
 wc.lpszMenuName   = NULL;
 wc.hIconSm        = NULL;
 iRet              = RegisterClassEx(&wc);
 #if defined MYDEBUG
 printf("      RegisterClassEx(Pane) = %d\n",iRet);
 #endif

 _tcscpy(szClassName,_T("Base"));      // Register Pane Class
 wc.lpszClassName  = szClassName;
 wc.lpfnWndProc    = fnBaseProc;
 wc.cbSize         = sizeof(wc);
 wc.style          = 0;
 wc.cbClsExtra     = 0;
 wc.cbWndExtra     = 0;
 wc.hInstance      = g_hModule;
 wc.hIcon          = LoadIcon(NULL,IDI_APPLICATION);
 wc.hCursor        = LoadCursor(NULL,IDC_ARROW);
 wc.hbrBackground  = (HBRUSH)GetStockObject(GRAY_BRUSH);
 wc.lpszMenuName   = NULL;
 wc.hIconSm        = NULL;
 iRet              = RegisterClassEx(&wc);
 #if defined MYDEBUG
 printf("      RegisterClassEx(Pane) = %d\n",iRet);
 #endif

 _tcscpy(szClassName,_T("Cell"));      // Register Cell Class
 wc.lpszClassName  = szClassName;
 wc.lpfnWndProc    = fnCellProc;
 wc.cbSize         = sizeof(wc);
 wc.style          = 0;
 wc.cbClsExtra     = 0;
 wc.cbWndExtra     = 4*sizeof(void*);
 wc.hInstance      = g_hModule;
 wc.hIcon          = LoadIcon(NULL,IDI_APPLICATION);
 wc.hCursor        = LoadCursor(NULL,IDC_ARROW);
 wc.hbrBackground  = (HBRUSH)GetStockObject(WHITE_BRUSH);
 wc.lpszMenuName   = NULL;
 wc.hIconSm        = NULL;
 iRet              = RegisterClassEx(&wc);
 #if defined MYDEBUG
 printf("      RegisterClassEx(Cell) = %d\n",iRet);
 printf("    Leaving Initialize()\n");
 #endif
}
//End Grid.cpp
